; GUARD stack ?
;
	.686
	.model flat, stdcall
	option casemap :none
	
	include \masm32\include\ntdll.inc
	includelib \masm32\lib\ntdll.lib

	include \masm32\include\kernel32.inc
	includelib \masm32\lib\kernel32.lib

.data?
Bits		RTL_BITMAP <>
Pages	BYTE 10000H DUP (?)


.code
; +
; Full update mm map.
;
; * mb use MemoryWorkingSetList(without subset).
;
MmDump proc
Local Mm:MEMORY_BASIC_INFORMATION
	invoke RtlClearAllBits, addr Bits
	and Mm.BaseAddress,NULL
	.repeat
		invoke ZwQueryVirtualMemory, NtCurrentProcess, Mm.BaseAddress, MemoryBasicInformation, addr Mm, sizeof(MEMORY_BASIC_INFORMATION), NULL
		test eax,eax
		jnz Exit
		.if Mm.Protect > PAGE_NOACCESS
			mov ecx,Mm.RegionSize
			mov eax,Mm.BaseAddress
			shr ecx,12
			shr eax,12	; /PAGE_SIZE
			inc ecx
			invoke RtlSetBits, addr Bits, Eax, Ecx
		.endif
		mov eax,Mm.RegionSize
		add Mm.BaseAddress,eax
	.until Mm.BaseAddress >= 7FFF0000H
	xor eax,eax
Exit:
	ret
MmDump endp

.data
DbgMissSet	ULONG ?	; WS idle event's.

.code
; +
; Update mm map via WS event.
;
; STATUS_NO_MORE_ENTRIES etc.
;
MmWatch proc uses ebx
Local Ws[512]:PROCESS_WS_WATCH_INFORMATION		; 8k max.
Local S1ze:ULONG
	invoke ZwQueryInformationProcess, NtCurrentProcess, ProcessWorkingSetWatch, addr Ws, PAGE_SIZE, addr S1ze
	.if !Eax
		lea ebx,Ws
		assume ebx:PPROCESS_WS_WATCH_INFORMATION
		.while [Ebx].FaultingPc
			.if [Ebx].FaultingVa > 7FFF0000H
				Int 3
			.endif
			mov ecx,[ebx].FaultingVa
			shr ecx,12	; /PAGE_SIZE << 4
			add ebx,sizeof PROCESS_WS_WATCH_INFORMATION
			bts D[Pages],ecx
			mov edx,[ebx].FaultingVa
			.if Carry?
				inc DbgMissSet
			.endif
		MmWatchFetch::
			mov cl,B[edx]
		.endw
	.endif
	ret
MmWatch endp

; +
; Add page to map.
;
MmSet proc Address:PVOID, S1ze:ULONG, State:BOOLEAN
	mov ecx,S1ze
	mov eax,Address
	shr ecx,12
	shr eax,12	; /PAGE_SIZE
	inc ecx
	.if State
		invoke RtlSetBits, addr Bits, Eax, Ecx
	.else
		invoke RtlClearBits, addr Bits, Eax, Ecx
	.endif
	ret
MmSet endp

Public MmPtrFetch

; 
; Validate of pointer.
; 
; OUT:
; 	CF if valid.
;	EAX bytes in current page.
;	EDX value after DF(B[P]).
;
MmPtr proc Address:PVOID
	mov eax,Address
	mov ecx,eax
	mov edx,eax
	and eax,PAGE_SIZE - 1
; Bytes in current page:
; PAGE_SIZE - OFFSET_IN_PAGE = PAGE_SIZE - (A & (PAGE_SIZE - 1))
	shr ecx,12
	not eax
	add eax,PAGE_SIZE + 1
	bt D [Pages],ecx
	.if Carry?
		; Check state(mb decommit) via DF. If N/A then clear bit in map.
MmPtrFetch::
		movzx edx,B [edx]
	.endif
	ret
MmPtr endp

Public MmGetFetch

;
; Get pointer state.
;
MmGet proc uses ebx Address:PVOID, S1ze:ULONG
	mov eax,Address
	mov ebx,S1ze
	mov eax,Address
	shr ebx,12
	shr eax,12
	inc ebx
	invoke RtlAreBitsSet, addr Bits, Eax, Ebx
	test eax,eax
	.if !Zero?
		; DF loop.
		mov ecx,Address
		xor eax,eax
	;	and ecx,NOT(PAGE_SIZE - 1)
		.repeat
		MmGetFetch::
			movzx edx,B[ecx]
			jc Fault	; Without update any pages.
			add ecx,PAGE_SIZE
			dec ebx
		.until Zero?
		inc eax
	.endif
Fault:
	ret
MmGet endp

; +
;
IsCurrentProcess proc ProcessHandle:HANDLE
Local Info:PROCESS_BASIC_INFORMATION
	.if ProcessHandle != NtCurrentProcess
		invoke ZwQueryInformationProcess, ProcessHandle, ProcessBasicInformation, addr Info, sizeof(PROCESS_BASIC_INFORMATION), NULL
		mov ecx,fs:[TEB.Cid.UniqueProcess]
		.if !Eax
			cmp Info.UniqueProcessId,ecx
		.endif
	.endif
	ret
IsCurrentProcess endp

%COPYARG macro Args
	mov eax,Args
	.repeat
		push D[ebp][sizeof(SFRAME)][eax*4][-4]
		dec eax
	.until Zero?
endm
	
xZwAllocateVirtualMemory proc ProcessHandle:HANDLE, BaseAddress:PPVOID, ZeroBits:ULONG, AllocationSize:PULONG, AllocationType:ULONG, Protect:ULONG
	%COPYARG 6
	Call gZwAllocateVirtualMemory.Build
	.if !Eax
		test AllocationType,MEM_COMMIT
		.if !Zero?
			test Protect,PAGE_NOACCESS
			.if Zero?
				invoke IsCurrentProcess, ProcessHandle
				.if Zero?
					mov ecx,BaseAddress
					mov edx,AllocationSize
					invoke MmSet, D[Ecx], D[Edx], TRUE
					xor eax,eax
				.endif
			.endif
		.endif
	.endif
	ret
xZwAllocateVirtualMemory endp

xZwFreeVirtualMemory proc ProcessHandle:HANDLE, BaseAddress:PPVOID, S1ze:PULONG, Flags:ULONG
	%COPYARG 4
	Call gZwFreeVirtualMemory.Build
	.if !Eax
		invoke IsCurrentProcess, ProcessHandle
		.if Zero?
			mov ecx,BaseAddress
			mov edx,S1ze
			invoke MmSet, D[Ecx], D[Edx], FALSE
		.endif
		xor eax,eax
	.endif
	ret
xZwFreeVirtualMemory endp


xZwMapViewOfSection proc SectionHandle:HANDLE, ProcessHandle:HANDLE, BaseAddress:PVOID, ZeroBits:ULONG, CommitSize:ULONG,
SectionOffset:PLARGE_INTEGER, ViewSize:PULONG, InheritDisposition:ULONG, AllocationType:ULONG, Protect:ULONG
	%COPYARG 10
	Call gZwMapViewOfSection.Build
	.if !Eax || (Eax == STATUS_IMAGE_NOT_AT_BASE)
		push eax
		invoke IsCurrentProcess, ProcessHandle
		.if Zero?
			mov ecx,BaseAddress
			mov edx,ViewSize
			invoke MmSet, D[Ecx], D[Edx], TRUE
		.endif
		pop eax
	.endif
	ret
xZwMapViewOfSection endp


MmQueryViewSize proc uses esi Base:PVOID
Local Mm:MEMORY_BASIC_INFORMATION
Local S1ze:ULONG
	mov eax,Base
	xor esi,esi
	mov Mm.BaseAddress,eax
	invoke ZwQueryVirtualMemory, NtCurrentProcess, Mm.BaseAddress, MemoryBasicInformation, addr Mm, sizeof(MEMORY_BASIC_INFORMATION), NULL
	.if !Eax
		mov esi,Mm.AllocationBase
		.if Mm._Type == MEM_IMAGE
			.repeat
				mov eax,Mm.RegionSize
				add Mm.BaseAddress,eax
				invoke ZwQueryVirtualMemory, NtCurrentProcess, Mm.BaseAddress, MemoryBasicInformation, addr Mm, sizeof(MEMORY_BASIC_INFORMATION), NULL
				test eax,eax
				jnz Fail
			.until Mm.AllocationBase != Esi
			mov edx,Mm.BaseAddress
			mov eax,esi
			sub edx,esi
		.else
			mov eax,Mm.BaseAddress
			mov edx,Mm.RegionSize
		.endif
	.else
Fail:
		xor eax,eax
	.endif
Exit:
	ret
MmQueryViewSize endp

xZwUnmapViewOfSection proc ProcessHandle:HANDLE, BaseAddress:PVOID
	invoke IsCurrentProcess, ProcessHandle
	.if Zero?
		invoke MmQueryViewSize, BaseAddress
		push eax
		push edx
		%COPYARG 2
		Call gZwUnmapViewOfSection.Build
		pop edx
		pop ecx
		.if !Eax
			invoke MmSet, Ecx, Edx, FALSE
			xor eax,eax
		.endif
	.else
		%COPYARG 2
		Call gZwUnmapViewOfSection.Build
	.endif
	ret
xZwUnmapViewOfSection endp
